#include "charge.h"

static int currentx = 300, currenty = 150;

void campaign_render()
{
	int tick = SDL_GetTicks();
	if (SDL_GetTicks() - gStateStartTick < 500)
	{
		gTextStartTick = SDL_GetTicks();
	}

	if (abs(gNextGraphicsTick - tick) > 1000)
	{
		gLastTick = tick;
		gNextGraphicsTick = tick;
	}
	while (gLastTick < tick)
	{
		currentx = (currentx * 15 + gCurrentLevel->flagx * 256) / 16;
		currenty = (currenty * 15 + gCurrentLevel->flagy * 256) / 16;

		gLastTick += 1000 / PHYSICSFPS;
	}

	int t = 500 - (SDL_GetTicks() - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	int q = 500 - (SDL_GetTicks() - gTextStartTick);
	if (q < 0) q = 0;
	q = (int)(SMOOTHSTEP(q / 500.0f)*500);	
	
	gMouseOver = 0;

	blit(gMenubg,0,0,800,600);

	blit(gMap,MapMenu.pos[0].x-t,MapMenu.pos[0].y,600,300);
	blit(gFlag,currentx / 256 + MapMenu.pos[0].x + t,currenty / 256 + MapMenu.pos[0].y,128,128);
	blit(gCurrentLevel->thumb, MapMenu.pos[1].x-q, MapMenu.pos[1].x, 170, 150);

	drawrectb(MapMenu.pos[2].x, MapMenu.pos[2].y-t, 408, 80,0);
	drawrectb(MapMenu.pos[2].x, MapMenu.pos[2].y-t, 408, 80,0);
	drawdescription(MapMenu.pos[2].x+4,MapMenu.pos[2].y+4-t,400,gCurrentLevel->desc, (SDL_GetTicks() - gTextStartTick) / 25);

	int ll = (int)strlen(gCurrentLevel->name) * 8;
	drawrectb(MapMenu.pos[2].x, 25+q-2+24, ll + 8, 12, 0);
	blitstring(MapMenu.pos[2].x+4,25+q+24,gCurrentLevel->name);

	drawrectb(MapMenu.pos[3].x,MapMenu.pos[3].y+t,208,88,0);
	char temp[80];
	blitstring(MapMenu.pos[3].x+4,MapMenu.pos[3].y+4+t,"Current score:");
	sprintf(temp, "%06d",gCampaignScore);
	blitstring32(MapMenu.pos[3].x+4,MapMenu.pos[3].y+4+8+t,temp);

	sprintf(temp, "(This level:%d)", gCurrentLevel->hiscore);
	blitstring(MapMenu.pos[3].x+4,MapMenu.pos[3].y+44+t,temp);

	blitstring(MapMenu.pos[3].x+4,MapMenu.pos[3].y+60+t,"Total needed to");
	sprintf(temp, "unlock this level:%d", gCurrentLevel->unlockscore);
	blitstring(MapMenu.pos[3].x+4,MapMenu.pos[3].y+68+t,temp);

	if (textbutton(4,MapMenu.pos[4].x + t,MapMenu.pos[4].y,"Back"))
	{
		if (gCurrentCampaign == 0)
			changestate(STATE_MENU);
		else
			changestate(STATE_SELECTCAMPAIGN);
	}

	if (gCurrentLevel->unlockscore > gCampaignScore)
	{
		drawrectb(MapMenu.pos[7].x,MapMenu.pos[7].y+q,23*8+8,32+8,0);
		drawrectb(MapMenu.pos[7].x,MapMenu.pos[7].y+q,23*8+8,32+8,0xff0000);
		blitstring(MapMenu.pos[7].x+4,MapMenu.pos[7].y+4+q,"!! LEVEL LOCKED !!");
		blitstring(MapMenu.pos[7].x+4,MapMenu.pos[7].y+20+q,"Reach high enough score");
		blitstring(MapMenu.pos[7].x+4,MapMenu.pos[7].y+28+q,"to unlock this level!");
	}
	else
	{
		if (textbutton(3,MapMenu.pos[7].x + t + 4,MapMenu.pos[7].y + 4,"Play"))
		{
			reset(gCurrentLevel);
			gReplayMode = 0;
			changestate(STATE_INGAME);
		}
	}

	if (textbutton(1,MapMenu.pos[5].x - t,MapMenu.pos[5].y,"Previous"))
	{
		if (gCurrentLevel == gLevelList)
			gCurrentLevel = NULL;
		Level * l = gLevelList;
		while (l->next != gCurrentLevel) l = l->next;
		gCurrentLevel = l;
		gTextStartTick = SDL_GetTicks();
	}

	if (textbutton(2,MapMenu.pos[6].x + t,MapMenu.pos[6].y,"Next"))
	{
		gCurrentLevel = gCurrentLevel->next;
		if (gCurrentLevel == NULL)
			gCurrentLevel = gLevelList;
		gTextStartTick = SDL_GetTicks();
	}

	if (gCurrentLevel->replay_exists && textbutton(13204,MapMenu.pos[8].x + t + 4,MapMenu.pos[8].y + 4,"Replay"))
	{
		reset(gCurrentLevel);
		gReplayMode = 1;
		read_replay(gCurrentLevel);
		changestate(STATE_INGAME);
	}

	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor
}
