#include "charge.h"
#include <float.h>

void ingame_goback();
void save_replay();

enum FAILURE_REASONS
{
 FAIL_OUTOFTIME,
 FAIL_DAMAGE,
 FAIL_SLOPPYJOB
};

int gReplayMode = 0;

int	gFailureReason;

int gScorePass;
int gScoreValuables;
int gScoreTime;
int gScoreAccuracy;
int gScoreBudget;
int gScoreDamage;

int levelscore;

// Last iteration's tick value
int gLastTick;

int gNextGraphicsTick;

Drill drill[64];

int mx = 100, my = 100;
int mousex, mousey;

int gActiveBomb;
int gActiveDrill;
int gFuseLength;

int gMouseActive = 0;
int gMouseOver = 0;
int gMouseDown = 0;
int gMouseIsDown = 0;
int gMouseDrag = 0;

//float gTargetDirection;
int gTargetDirection;
int gTargetColor;
int gShakes;
int gPhysicsTick = 0;

int gMouseState = MOUSE_IDLE;


void checkmouseover()
{
	int i;
	for (i = 0; i < 13; i++)
	{
		if (mx <= (mouseinfo[i].x + mouseinfo[i].w) &&
			my <= (mouseinfo[i].y + mouseinfo[i].h) &&
			mx >= mouseinfo[i].x &&			
			my >= mouseinfo[i].y)
		{
			gMouseOver = mouseinfo[i].id;			
			return;
		}
	}
	gMouseOver = 0;
}

int cursor_blocked()
{
		int p = mx - 120 + my * 680;
		if (gBlockMask && ((unsigned int *)gBlockMask->pixels)[p])
			return 1;
		if (mx < 120 || (grainmap[p] >= 0 && !(particle[grainmap[p]].type & GRAIN_FLUID)))
			return 1;
		return 0;
}

void spawndrill(int x, int y)
{
	int p = x + y * 680;	

	if (cursor_blocked())
		return;

	if (gCurrentLevel->drillcount[gActiveDrill] >= 0 && gCurrentLevel->drillcount[gActiveDrill] <= gFuseLength)
		return;
	if (gCurrentLevel->bombcount[gActiveBomb] == 0)
		return;	
	
	gCurrentLevel->drillcount[gActiveDrill] -= gFuseLength + 1;
	if (gCurrentLevel->bombcount[gActiveBomb] > 0)
		gCurrentLevel->bombcount[gActiveBomb]--;

	int cost = bombinfo[gCurrentLevel->bomb[gActiveBomb]].cost + (gFuseLength + 1) * drillinfo[gCurrentLevel->drill[gActiveDrill]].cost;
	if (cost > gCurrentMoney)
		return;
	gCurrentMoney -= cost;

	int d = 0;
	while (d < 64 && drill[d].drilltype >= 0) d++;
	if (d == 64) return;
	drill[d].drilltype = gCurrentLevel->drill[gActiveDrill];
	drill[d].bombtype = gCurrentLevel->bomb[gActiveBomb];
	drill[d].ttl = 20 + 20 * gFuseLength;
	
	drill[d].x = (float)x;
	drill[d].y = (float)y;
	drill[d].direction = (float)(drillinfo[drill[d].drilltype].misdirection * prand.genrand_real1() + (gTargetDirection / 16.0f * PI * 2));
	drill[d].color = gTargetColor;

	if (!gReplayMode)
	{
		replaybuffer[gReplayIndex].bomb = gActiveBomb;
		replaybuffer[gReplayIndex].drill = gActiveDrill;
		replaybuffer[gReplayIndex].direction = gTargetDirection;
		replaybuffer[gReplayIndex].fuse = gFuseLength;
		replaybuffer[gReplayIndex].physicstick = gPhysicsTick;
		replaybuffer[gReplayIndex].x = x;
		replaybuffer[gReplayIndex].y = y;
		gReplayIndex++;
		if (gReplayIndex >= 1023) gReplayIndex = 1022;
	}

	//int ch = FSOUND_PlaySound(FSOUND_FREE, drillinfo[drill[d].drilltype].drillsound);
	//FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
	//FSOUND_SetPan(ch, (x * 255 / 680));
	//drill[d].soundhandle = ch;
}

void drill_explosion(int x, int y, int r, int str, int iter, int branch, int type, float direction)
{
	if (x < 0 || y < 0 || x >= 679 || y >= 599)
		return;
	iter--;
	DelayedDig * d = new DelayedDig;
	d->next = gDelayedDigRoot;
	gDelayedDigRoot = d;
	d->x = x;
	d->y = y;
	d->r = r;
	d->pow = str;

	if (iter > 0)
	{
		int i;
		int tp = type;
		int cr = r;
		for (i = 0; i < branch; i++)
		{
			float dir = (float)(prand.genrand_real1() * PI * 2.0);			
			switch (tp)
			{
			case 1:
				dir = dir / 8 - (PI + PI / 8);
				break;
			case 2:
				dir = dir / 8 - (PI / 8);
				break;
			case 3:
                direction = dir;				
				type = 500;
				r = (iter / 8) + 1;
				break;
			case 500:
				direction = dir = direction + (dir / 8.0f) - (PI / 8.0f);
				r = (iter / 8) + 1;
				break;
			default:				
				break;
			}
			drill_explosion((int)(x + sin(dir)*cr),(int)(y + cos(dir)*cr),r,str,iter,1,type,direction);
		}
	}
}

// TODO: split this into visual and non-visual parts
void check_goals()
{
	int i, j;
	if (gCheckActive)
	{
		if (gCurrentLevel->pass > 0)
		{
			for (i = 0; i < 600; i++)
			{
				int clpos = (gCheckLayer->pitch / 4) * i;
				memset(((unsigned int*)gCheckLayer->pixels) + clpos, 0, 680 * 4);
			}
		}
	}

	// First, check if any drills are on the move.
	for (i = 0; i < 64; i++)
	{
		if (drill[i].drilltype >= 0)
		{
			gTextStartTick = gPhysicsTick;
			return; // if so, don't check the goals yet.
		}
	}

	if (gIngameState != STATE_PLAYING)
	{
		if ((gPhysicsTick - gTextStartTick) > 5 * 50)
			ingame_goback();
		return; // don't overrule the old result (can win even if loss comes afterwards)
	}

	if (gCurrentLevel->time)
	{
		
		if ((gPhysicsTick / 50) > gCurrentLevel->time)
		{
			gTextStartTick = gPhysicsTick;
			gIngameState = STATE_LOST;
			gFailureReason = FAIL_OUTOFTIME;
			return;
		}
	}

	if (gTotalNoharm > 0)
	{
		if (gCurrentNoharm > gTotalNoharm * (1 - gCurrentLevel->noharm))
		{
			gTextStartTick = gPhysicsTick;
			gIngameState = STATE_LOST;
			gFailureReason = FAIL_DAMAGE;
			return;
		}
	}

	if (gCurrentLevel->pass > 0)
	{
		if (gCurrentLevel->pass == 1)
		{
			// trace path
			int tick = gPhysicsTick - gTextStartTick;
			int r = (tick >> 1) & 15;
			int lemmingx = gCurrentLevel->x1;
			int lemmingy = gCurrentLevel->y1;
			int lemmingdir = (gCurrentLevel->x1 < gCurrentLevel->x2) ? 1 : -1;
			int steps = 0;
			int maxsteps = (tick << 1) % 1200;
			while (steps < maxsteps)
			{
				int p = lemmingy * 680 + lemmingx;
				if (p < 680*599 && grainmap[p + 680] < 0)
				{
					lemmingy++;
				}
				else
				if (grainmap[p + lemmingdir] < 0)
				{
					lemmingx += lemmingdir;
				}
				else
				if (grainmap[p + lemmingdir - 680] < 0)
				{
					lemmingy --;
					lemmingx += lemmingdir;
				}
				else
				if (grainmap[p + lemmingdir - 680 * 2] < 0)
				{
					lemmingy -= 2;
					lemmingx += lemmingdir;
				}
				else
				if (grainmap[p + lemmingdir - 680 * 3] < 0)
				{
					lemmingy -= 3;
					lemmingx += lemmingdir;
				}
				else
				{
					lemmingdir *= -1;
				}
				if (lemmingx < 0)
				{
					lemmingx = 0;
					lemmingdir *= -1;
				}
				if (lemmingx > 679)
				{
					lemmingx = 679;
					lemmingdir *= -1;
				}
				steps++;
				if (gCheckActive)
					drawcirclecheck(lemmingx, lemmingy, 2, 0x007700, 0);
			}
			if (gCheckActive)
			{
				drawcirclecheck(lemmingx, lemmingy, 3, 0x00ff00, 0);
				drawcirclecheck(gCurrentLevel->x1, gCurrentLevel->y1, (r * r) / 8, 0x00ff00, 1);
				drawcirclecheck(gCurrentLevel->x2, gCurrentLevel->y2, (r * r) / 8, 0xff0000, 1);
				drawcirclecheck(gCurrentLevel->x1, gCurrentLevel->y1, r / 2, 0x00ff00, 0);
				drawcirclecheck(gCurrentLevel->x2, gCurrentLevel->y2, r / 2, 0xff0000, 0);
			}
			if (sqrt((float)((lemmingx - gCurrentLevel->x2) * (lemmingx - gCurrentLevel->x2) +
					  (lemmingy - gCurrentLevel->y2) * (lemmingy - gCurrentLevel->y2))) > 8)
			{
				return;
			}
		}
		if (gCurrentLevel->pass == 2)
		{
			int pass = 1;
			for (i = gCurrentLevel->y1; i < gCurrentLevel->y2; i++)
			{
				int clpos = i * (gCheckLayer->pitch / 4);
				int glpos = i * 680;
				for (j = gCurrentLevel->x1; j < gCurrentLevel->x2; j++)
				{
					if (grainmap[glpos + j] < 0)
					{
						((unsigned int*)gCheckLayer->pixels)[clpos + j] = 0xff0000;
						pass = 0;
					}
					else
					{
						((unsigned int*)gCheckLayer->pixels)[clpos + j] = 0x00ff00;
					}
				}
			}
			if (!pass)
				return;
		}
	}

	int accuracymaskpoints = 0;
	int accuracyscore = 0;

	if (gCurrentLevel->accuracyfile)
	{
		int notcleared = 0;
		for (i = 0; i < 600; i++)
		{
			int clpos = i * (gCheckLayer->pitch / 4);
			int glpos = i * 680;			
			for (j = 0; j < 680; j++)
			{
				if (((unsigned int*)gCheckLayer->pixels)[clpos + j])
				{
					if (grainmap[glpos + j] >= 0)
						notcleared++;
					accuracymaskpoints++;
				}
			}
		}
		if (notcleared > (accuracymaskpoints * (1.0f - gCurrentLevel->clearpercent)))
			return; // not cleared
		accuracyscore = (int)floor(gCurrentLevel->score_accuracymax - (gCurrentDugTotal - accuracymaskpoints + notcleared) * gCurrentLevel->score_accuracypenalty);
		if (accuracyscore < 0)
		{
			gTextStartTick = gPhysicsTick;
			gIngameState = STATE_LOST;
			gFailureReason = FAIL_SLOPPYJOB;
			return;
		}
	}


	if (gTotalValuables > 0)
	{
		if (gCurrentValuables < gTotalValuables * gCurrentLevel->valuables)
			return;
	}

	// all goals fulfilled

	gScorePass = (int)gCurrentLevel->score_pass;
	gScoreValuables = (int)(gCurrentLevel->score_valuablepercent * gCurrentValuables / gTotalValuables);
	gScoreTime = (int)(gCurrentLevel->score_timepersec * (gCurrentLevel->time - (gPhysicsTick / 50)));
	gScoreAccuracy = accuracyscore;
	gScoreBudget = (int)(gCurrentLevel->score_budget * gCurrentMoney);
	gScoreDamage = (int)(gCurrentLevel->score_noharmpercent * gCurrentNoharm / gTotalNoharm);

	levelscore = gScorePass + gScoreValuables + gScoreTime + gScoreAccuracy + gScoreBudget - gScoreDamage;
		
	if (levelscore < 0)
		levelscore = 0;

	gTextStartTick = gPhysicsTick;
	gIngameState = STATE_WON;

	int total = read_state("missionswon");
	total++;
	set_state("missionswon", total);


	if (levelscore > gCurrentLevel->hiscore)
	{
		set_state(gCurrentLevel->filename, levelscore);
		gCurrentLevel->hiscore = levelscore;
		serialize_states();
	}
}

void physics(int tick)
{
	int i, j;

	_control87(_PC_24, MCW_PC); // just in case

	while (gLastTick < tick)
	{
		if (gReplayMode)
		{
			if (replaybuffer[gReplayIndex].physicstick == gPhysicsTick)
			{
				gActiveBomb = replaybuffer[gReplayIndex].bomb;
				gActiveDrill = replaybuffer[gReplayIndex].drill;
				gFuseLength = replaybuffer[gReplayIndex].fuse;
				gTargetDirection = replaybuffer[gReplayIndex].direction;
				mx = mousex = replaybuffer[gReplayIndex].x + 120;
				my = mousey = replaybuffer[gReplayIndex].y;
				spawndrill(replaybuffer[gReplayIndex].x, replaybuffer[gReplayIndex].y);
				gReplayIndex++;
			}
			if (gReplayIndex == 0 || replaybuffer[gReplayIndex].physicstick < 0)
			{
				mousex = mx = (mx * 7 + replaybuffer[gReplayIndex].x + 120) / 8;
				mousey = my = (my * 7 + replaybuffer[gReplayIndex].y) / 8;
			}
			else
			{
				float v = (gPhysicsTick - replaybuffer[gReplayIndex-1].physicstick) /
					      (float)(replaybuffer[gReplayIndex].physicstick - replaybuffer[gReplayIndex-1].physicstick);
				v = SMOOTHSTEP(v);
				v = SMOOTHSTEP(v);
				float iv = 1.0f - v;
				mousex = mx = (int)(replaybuffer[gReplayIndex-1].x * iv + replaybuffer[gReplayIndex].x * v) + 120;
				mousey = my = (int)(replaybuffer[gReplayIndex-1].y * iv + replaybuffer[gReplayIndex].y * v);
				gFuseLength = (int)(replaybuffer[gReplayIndex-1].fuse * iv + replaybuffer[gReplayIndex].fuse * v);
				if (v >= 0.5f)
				{
					gActiveBomb = replaybuffer[gReplayIndex].bomb;
					gActiveDrill = replaybuffer[gReplayIndex].drill;
				}
			}
		}

		gPhysicsTick++;

		particle_physics();

		if (gDelayedDigRoot)
		{
			DelayedDig * d = gDelayedDigRoot;
			DelayedDig * b = d;
			int maxr = 0;
			while (d)
			{
				if (d->r > maxr)
				{
					maxr = d->r;
					b = d;
				}
				d = d->next;
			}
				
			if (maxr < 8)
			{
				/*
				if (tick - gExplosionSoundTick > 100)
				{
					gExplosionSoundTick = tick;
					int ch = FSOUND_PlaySound(FSOUND_FREE, gSampleSmallEx);
					FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
					FSOUND_SetPan(ch, (b->x * 255 / 680));
				}
				*/
			}
			
			d = gDelayedDigRoot;
			gDelayedDigRoot = NULL;
			while (d)
			{
				DelayedDig *l = d;
				drillcircle(d->x, d->y, d->r, d->pow);
				add_explosion(d->x, d->y, 8, 3, 1);
				d = d->next;
				delete l;
			}
		}
		
		collapse();
		if (gShakes && !(gPhysicsTick & 7))
		{
			shake();
			gShakes--;
		}
		for (i = 0; i < 64; i++)
		{
			if (drill[i].drilltype >= 0)
			{
				// if in air, drop down fast
				int p = (int)drill[i].x + ((int)drill[i].y) * 680;
				if (p < 680 * 590)
				{
					for (j = 0; j < 5; j++)
					{
						if ((grainmap[p + 2*680] < 0 || particle[grainmap[p + 2*680]].type & GRAIN_FLUID) &&
							(grainmap[p + 2*680 - 1] < 0  || particle[grainmap[p + 2*680 - 1]].type & GRAIN_FLUID) &&
							(grainmap[p + 2*680 + 1] < 0  || particle[grainmap[p + 2*680 + 1]].type & GRAIN_FLUID))
						{
							drill[i].y++;
							p += 680;
						}
						else
						{
							j = 5; // stop falling (don't fall through thin walls)
						}						
					}
				}
				
				drill[i].direction += drillinfo[drill[i].drilltype].bias;
				drill[i].direction += (float)((prand.genrand_real1() - 0.5) * drillinfo[drill[i].drilltype].shaky);

				p = (int)(drill[i].x - cos(drill[i].direction)) + ((int)(drill[i].y - sin(drill[i].direction))) * 680;
				if (p > 0 && p < (680*600) && (grainmap[p] < 0 || particle[grainmap[p]].hits < 0 || particle[grainmap[p]].type & GRAIN_FLUID))
				{
					drill[i].x += - cos(drill[i].direction);
					drill[i].y += - sin(drill[i].direction);
					if (drill[i].x >= 679)
						drill[i].x = 679;
					if (drill[i].x < 1)
						drill[i].x = 1;
					if (drill[i].y < 1)
						drill[i].y = 1;
					if (drill[i].y > 599)
						drill[i].y = 599;
				}
				drill[i].ttl--;
				drillrect((int)floor(drill[i].x-1), (int)floor(drill[i].y-1), 3, 3, drillinfo[drill[i].drilltype].drillstrength);
				if (drill[i].ttl <= 0)
				{
					int x = (int)floor(drill[i].x);
					int y = (int)floor(drill[i].y);
					if (x < 1) x = 1;
					if (y < 1) y = 1;
					if (x > 678) x = 678;
					if (y > 598) y = 598;
					//FSOUND_StopSound(drill[i].soundhandle);
					//int ch = FSOUND_PlaySound(FSOUND_FREE, bombinfo[drill[i].bombtype].explosionsound);
					//FSOUND_SetVolume(ch, (gSfxVolume * 255) / 100);
					//FSOUND_SetPan(ch, (x * 255 / 680));
					
					drill_explosion(x, y, bombinfo[drill[i].bombtype].explosionrange, bombinfo[drill[i].bombtype].explosionstrength, bombinfo[drill[i].bombtype].eiterations, bombinfo[drill[i].bombtype].ebranches, bombinfo[drill[i].bombtype].type, 0);
					gShakes += bombinfo[drill[i].bombtype].shakes;
					add_explosion((int)drill[i].x, (int)drill[i].y, bombinfo[drill[i].bombtype].vrange, bombinfo[drill[i].bombtype].piterations, bombinfo[drill[i].bombtype].pbranches);
					
					drill[i].drilltype = -1;
				}
			}
		}
		check_goals();
		gLastTick += 1000 / PHYSICSFPS;
	}
	if (PHYSICSFPS > gFPSCap)
		gNextGraphicsTick += (1000 / gFPSCap);
	else
		gNextGraphicsTick = gLastTick;	
}


int ingame_render()
{   
	int tick = SDL_GetTicks();
	int i, j, c;
	char temp[256];

	if (abs(gNextGraphicsTick - tick) > 1000)
	{
		gLastTick = tick;
		gNextGraphicsTick = tick;
	}

	SDL_Delay(1);
	if (tick <= gNextGraphicsTick) 
	{
		return 0;
	}

	int mspf1 = SDL_GetTicks();

	physics(tick);	

	int mspfp2 = SDL_GetTicks();

	if (gBackground)
		blit(gBackground,120,0,680,600);
	else
		blitrect(120,0,680,600,0);

	blit(gCommands,0,0,120,600);	

	if (gMouseOver != 0)
		blitpiece(gCommandsHot, mouseinfo[gMouseOver-1].x, mouseinfo[gMouseOver-1].y, mouseinfo[gMouseOver-1].w, mouseinfo[gMouseOver-1].h);

	if (gCheckActive)
		blitpiece(gCommandsActive, mouseinfo[12].x, mouseinfo[12].y, mouseinfo[12].w, mouseinfo[12].h);

	blitpiece(gCommandsActive, mouseinfo[gActiveDrill].x, mouseinfo[gActiveDrill].y, mouseinfo[gActiveDrill].w, mouseinfo[gActiveDrill].h);
	blitpiece(gCommandsActive, mouseinfo[gActiveBomb+5].x, mouseinfo[gActiveBomb+5].y, mouseinfo[gActiveBomb+5].w, mouseinfo[gActiveBomb+5].h);

	if (gMouseDown != 0)
		blitpiece(gCommandsDown, mouseinfo[gMouseDown-1].x, mouseinfo[gMouseDown-1].y, mouseinfo[gMouseDown-1].w, mouseinfo[gMouseDown-1].h);


	for (i = 0; i < 5; i++)
	{
		alphaburn(gBombs, 0, gCurrentLevel->bomb[i] * 32, 32, 32, mouseinfo[i + 5].x+14+2, mouseinfo[i + 5].y+14+2);
		if (gCurrentLevel->bombcount[i] != 0)
			alphablit(gBombs, 0, gCurrentLevel->bomb[i] * 32, 32, 32, mouseinfo[i + 5].x+14, mouseinfo[i + 5].y+14);

		alphaburn(gDrills, 0, gCurrentLevel->drill[i] * 32, 32, 32, mouseinfo[i].x+14+2, mouseinfo[i].y+14+2);
		if (gCurrentLevel->drillcount[i] != 0)
			alphablit(gDrills, 0, gCurrentLevel->drill[i] * 32, 32, 32, mouseinfo[i].x+14, mouseinfo[i].y+14);
	}

	blitstring(10,10,gCurrentLevel->name);	
/*
	drawrect(125,5,(int)strlen(TITLE)*8+10,5+8+5,0);
	blitstring(130,10,TITLE);	
*/

	sprintf(temp,"Budget $%d",gCurrentMoney);
	blitstring(5,40,temp);
	int time = gPhysicsTick / 50;
	if (gCurrentLevel->time != 0)
	{
		time = gCurrentLevel->time - time;
		if (time < 0)
			time = 0;
	}
	sprintf(temp,"Time %d:%02d",time/60,time%60);
	blitstring(5,50,temp);
	if (gTotalValuables)
	{
		sprintf(temp,"Valuables %3.0f%%",(gCurrentValuables / (float)gTotalValuables) * 100);
		blitstring(5,60,temp);
	}
	if (gTotalNoharm)
	{
		sprintf(temp,"Property  %3.0f%%",(1-(gCurrentNoharm / (float)gTotalNoharm)) * 100);
		blitstring(5,70,temp);
	}

	for (i = 0; i < 13; i++)
	{
		if (mouseinfo[i].id < 11)
		{
			if (mouseinfo[i].id < 6)
				sprintf(temp, "$%d", drillinfo[gCurrentLevel->drill[mouseinfo[i].id-1]].cost);
			else
				sprintf(temp, "$%d", bombinfo[gCurrentLevel->bomb[mouseinfo[i].id-6]].cost);
			blitstring(mouseinfo[i].x+mouseinfo[i].w-(int)strlen(temp)*8,
				       mouseinfo[i].y,
					   temp);

			if (mouseinfo[i].id < 6)
			{
				if (gCurrentLevel->drillcount[mouseinfo[i].id-1] >= 0)
					sprintf(temp, "#%d", gCurrentLevel->drillcount[mouseinfo[i].id-1]);
				else
					sprintf(temp,"%s","inf");
			}
			else
			{
				if (gCurrentLevel->bombcount[mouseinfo[i].id-6] >= 0)
					sprintf(temp, "#%d", gCurrentLevel->bombcount[mouseinfo[i].id-6]);
				else
					sprintf(temp,"%s","inf");
			}
			blitstring(mouseinfo[i].x+mouseinfo[i].w-(int)strlen(temp)*8,
				       mouseinfo[i].y+8,
					   temp);
		}
	}


	blitpiece(gCommandsActive, mouseinfo[10].x, mouseinfo[10].y, gFuseLength * 10, mouseinfo[10].h);

	sprintf(temp, "%d x $%d", gFuseLength + 1, drillinfo[gCurrentLevel->drill[gActiveDrill]].cost);
	blitstring(mouseinfo[10].x+mouseinfo[10].w-(int)strlen(temp)*8,
				       mouseinfo[10].y,
					   temp);
	sprintf(temp, "+ $%d", bombinfo[gCurrentLevel->bomb[gActiveBomb]].cost);
	blitstring(mouseinfo[10].x+mouseinfo[10].w-(int)strlen(temp)*8,
				       mouseinfo[10].y + 8,
					   temp);
	sprintf(temp, "= $%d", bombinfo[gCurrentLevel->bomb[gActiveBomb]].cost + (gFuseLength + 1) * drillinfo[gCurrentLevel->drill[gActiveDrill]].cost);
	blitstring(mouseinfo[10].x+mouseinfo[10].w-(int)strlen(temp)*8,
				       mouseinfo[10].y + 16,
					   temp);

	// Lock surface if needed
	if (SDL_MUSTLOCK(gScreen))
		if (SDL_LockSurface(gScreen) < 0) 
			return 0;


	c = 0;
	for (i = 0; i < 600; i++)
	{
		int slpos = i * gScreen->pitch / 4;
		for (j = 0; j < 680; j++, c++)
		{
			if (grainmap[c] >= 0)
			{
				((unsigned int*)gScreen->pixels)[120 + slpos + j] = particle[grainmap[c]].color;
			}
		}
	}

	for (i = 0; i < 64; i++)
	{
		if (drill[i].drilltype >= 0)
		{
			drawrect((int)floor(drill[i].x-1)+120, (int)floor(drill[i].y-1),3,3,drill[i].color);
		}
	}

	render_particles();

	if (gEnableLittleTouches)
		bloom();

	if (gCheckActive)
	{
		for (i = 0; i < 600; i++)
		{
			int slpos = i * gScreen->pitch / 4;
			int clpos = i * gCheckLayer->pitch / 4;
			for (j = 0; j < 680; j++)
			{
				int cl = ((unsigned int*)gCheckLayer->pixels)[clpos + j];
				int ofs = 120 + slpos + j;
				if (cl)
				{
					((unsigned int*)gScreen->pixels)[ofs] = 
						blend_avg(((unsigned int*)gScreen->pixels)[ofs], cl);
				}
			}
		}
	}


	// Unlock if needed
    if (SDL_MUSTLOCK(gScreen)) 
        SDL_UnlockSurface(gScreen);

	if (!gReplayMode || replaybuffer[gReplayIndex].physicstick >= 0) // don't display cursor when replay data runs out
	{
		if (mx < 120 || gIngameState != STATE_PLAYING)
		{
			blitcursor(mx, my, 0); // selector cursor
		}
		else
		{
			if (cursor_blocked())
			{
				blitcursor(mx, my, 1); // blocked cursor
			}
			else
			{
				int p = mx - 120 + my * 680;

				if (grainmap[p-1] >= 0 ||
					grainmap[p+1] >= 0 ||
					grainmap[p+680] >= 0 ||
					grainmap[p-680] >= 0)
				{
					blitcursor(mx, my, 3); // next to ground
				}
				else
				{
					blitcursor(mx, my, 2); // in the air
				}					
			}
			blitrect(mx-1, my-1, 3, 3, gTargetColor);
			if (gMouseState == MOUSE_DIRECTION)
			{
				float dir = atan2((float)(my-mousey), (float)(mx-mousex));
				if (my == mousey && mx == mousex)
					dir = PI * -0.5;
				int direction = (int)floor((dir / (PI*2))*16 + 0.5);
				if (direction > 7) direction--;
				float td = (direction) / 16.0f * PI * 2;
				gTargetDirection = direction;
				blitdirection((int)floor(mx - cos(td) * 48), 
							(int)floor(my - sin(td) * 48), direction + 8);
				
				if (gMouseDrag)
				{
					sprintf(temp,"%02d",gFuseLength+1);
					drawrectb(mousex - 32 - 4, mousey - 16 - 4, 64 + 8, 32 + 8, 0);
					blitstring32(mousex - 32, mousey - 16, temp);
				}
				else
				{
					blitcursor(mousex, mousey, 0);
				}
				
				int cost = bombinfo[gCurrentLevel->bomb[gActiveBomb]].cost + (gFuseLength + 1) * drillinfo[gCurrentLevel->drill[gActiveDrill]].cost;
				sprintf(temp,"$%d", cost);
				int l = (int)strlen(temp) * 8;
				drawrectb(mousex - l / 2 - 2, mousey - 32 - 4 - 2, l + 4, 8 + 4, 0);
				if (cost > gCurrentMoney || 
					(gCurrentLevel->drillcount[gActiveDrill] >= 0 && gCurrentLevel->drillcount[gActiveDrill] <= gFuseLength) ||
					gCurrentLevel->bombcount[gActiveBomb] == 0)
				{
					drawrectb(mousex - l / 2 - 4, mousey - 32 - 4- 4, l + 8, 8 + 8, 0xff0000);
					blitstring(mousex - l / 2, mousey - 4 - 32, temp);
					if (cost > gCurrentMoney)
					{
						drawrectb(mousex - (12 * 8) / 2 - 4, mousey + 32 - 4, 12 * 8 + 8, 8 + 8, 0xff0000);
						blitstring(mousex - (12 * 8) / 2, mousey + 32, "Out of money");
					}
					else
					if (gCurrentLevel->drillcount[gActiveDrill] >= 0 && gCurrentLevel->drillcount[gActiveDrill] <= gFuseLength)
					{
						drawrectb(mousex - (11 * 8) / 2 - 4, mousey + 32 - 4, 11 * 8 + 8, 8 + 8, 0xff0000);
						blitstring(mousex - (11 * 8) / 2, mousey + 32, "Out of fuse");
					}
					else
					{
						drawrectb(mousex - (12 * 8) / 2 - 4, mousey + 32 - 4, 12 * 8 + 8, 8 + 8, 0xff0000);
						blitstring(mousex - (12 * 8) / 2, mousey + 32, "Out of bombs");
					}

				}
				else
				{
					blitstring(mousex - l / 2, mousey - 4 - 32, temp);
					if (gMouseDrag)
					{
						drawrectb(mousex - (11 * 8) / 2 - 4, mousey + 32 - 4, 11 * 8 + 8, 8 + 8, 0);
						blitstring(mousex - (11 * 8) / 2, mousey + 32, "Fuse length");
					}			
				}
			}
		}
	}

	if (gReplayMode)
	{
		if ((tick >> 10) & 1)
			blitstring32(800-32-10,10,"R");
		else
			blitstring(800-8-10,10,"R");
	}

	switch (gIngameState)
	{
	case STATE_WON:
		i = (gPhysicsTick - gTextStartTick) * 20;
		i = 300 - i;
		if (i < 0) i = 0;
		drawrectb(120 + (680 - 8*32)/2 - 16,280 + i,8*32+32,48,0);
		blitstring32(120 + (680 - 8*32)/2, 288 + i, "You won!");
		sprintf(temp,"Score:%d",levelscore);
		drawrectb(120 + (680 - (int)strlen(temp) * 32)/2 - 16,340 - i,(int)strlen(temp) * 32 + 32,48,0);
		blitstring32(120 + (680 - (int)strlen(temp) * 32)/2, 348 - i, temp);

		{
			int linesneeded = 0;
			if (gScorePass) linesneeded++;
			if (gScoreValuables) linesneeded++;
			if (gScoreTime) linesneeded++;
			if (gScoreAccuracy) linesneeded++;
			if (gScoreBudget) linesneeded++;
			if (gScoreDamage) linesneeded++;
			if (linesneeded > 0)
				drawrectb(360, 390 - i, 200, 8 + 8 * linesneeded, 0);
			int line = 0;
			if (gScorePass)
			{
				sprintf(temp,"Passed         %-6d", gScorePass);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
			if (gScoreValuables)
			{
				sprintf(temp,"Valuables      %-6d", gScoreValuables);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
			if (gScoreTime)
			{
				sprintf(temp,"Time left      %-6d", gScoreTime);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
			if (gScoreAccuracy)
			{
				sprintf(temp,"Accuracy       %-6d", gScoreAccuracy);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
			if (gScoreBudget)
			{
				sprintf(temp,"Money left     %-6d", gScoreBudget);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
			if (gScoreDamage)
			{
				sprintf(temp,"Damage         %-6d", -gScoreDamage);
				blitstring(364, 394 - i + line * 8, temp);
				line++;
			}
		}

		break;
	case STATE_LOST:
		i = (gPhysicsTick - gTextStartTick) * 20;
		i = 300 - i;
		if (i < 0) i = 0;
		drawrectb(200,280+i,400,48,0);
		blitstring32(208 + (400 - 11*32)/2, 288+i, "You failed.");
		switch (gFailureReason)
		{
		case FAIL_OUTOFTIME:
			drawrectb(208 + (400 - 12*32)/2-8,348-i-8,12*32+16,32+16,0);
			blitstring32(208 + (400 - 12*32)/2, 348-i, "Out of time!");
			break;
		case FAIL_DAMAGE:
			drawrectb(208 + (400 - 16*32)/2-8,348-i-8,16*32+16,32+16,0);
			blitstring32(208 + (400 - 16*32)/2, 348-i, "Too much damage!");
			break;
		case FAIL_SLOPPYJOB:
			drawrectb(208 + (400 - 13*32)/2-8,348-i-8,13*32+16,32+16,0);
			blitstring32(208 + (400 - 13*32)/2, 348-i, "Dug too much!");
			break;
		}
		break;
	}

	int mspf2 = SDL_GetTicks();
/*
	static int lmspf = 0;
	static int mspf[10];
	static int mspfp[10];
	if (gPerfInfo)
	{
		mspf[lmspf] = mspf2 - mspf1;
		mspfp[lmspf] = mspfp2 - mspf1;
		lmspf++;
		if (lmspf == 10) lmspf = 0;
		float f = 0, fp = 0;
		for (i = 0; i < 10; i++)
		{
			f += mspf[i];
			fp += mspfp[i];
		}

		sprintf(temp, "Sparkle  : %d", gActiveSparkles);
		blitstring(600,0,temp);
		sprintf(temp, "Explosion: %d", gActiveExplosions);
		blitstring(600,8,temp);
		sprintf(temp, "Smoke    : %d", gActiveSmokes);
		blitstring(600,16,temp);
		sprintf(temp, "FPS      : %3.3f", 10000.0f / f);
		blitstring(600,24,temp);
		sprintf(temp, "MSPF     : %3.3f", f / 10.0f);
		blitstring(600,32,temp);
		sprintf(temp, "MSPFp    : %3.3f", fp / 10.0f);
		blitstring(600,40,temp);
		sprintf(temp, "Phys%%    : %3.3f%%", (fp / f) * 100.0f);
		blitstring(600,48,temp);
	}
*/
	return 1;
}

void selectdrill(int drill)
{	
	gActiveDrill = drill;
}

void selectbomb(int bomb)
{
	gActiveBomb = bomb;
	gTargetColor = bombinfo[bomb].color;
}

void ingame_goback()
{
	// stop looping sounds
	int i;
	for (i = 0; i < 64; i++)
	{
		if (drill[i].drilltype >= 0)
		{
			//FSOUND_StopSound(drill[i].soundhandle);
		}
	}

	if (!gReplayMode)
	{
		replaybuffer[gReplayIndex].physicstick = -1;
		replaybuffer[gReplayIndex].x = mx - 120;
		if (replaybuffer[gReplayIndex].x < 0)
			replaybuffer[gReplayIndex].x = 0;
		replaybuffer[gReplayIndex].y = my;
		gReplayIndex++;

		int savereplay = 0;
		if (gCurrentLevel->hiscore == levelscore)
			savereplay = 1;
		else
		if (read_state("replay"))
			savereplay = 1;
		if (savereplay)
			save_replay();

		// record total playing time..
		int total = read_state("totalplayingtime");
		total += gPhysicsTick / 50;
		set_state("totalplayingtime", total);
		// ..dug bits..
		total = read_state("totaldug");
		total += gCurrentDugTotal / 1000;
		set_state("totaldug", total);
		// ..missions played..
		total = read_state("missionsplayed");
		total++;
		set_state("missionsplayed", total);

		serialize_states();
	}

	switch (gCurrentCampaign)
	{
	case -2:
		changestate(STATE_SINGLE);
		break;
	case -1:
		changestate(STATE_MENU);
		break;
	default:
		changestate(STATE_CAMPAIGN);
		break;
	}
}

void leftclick()
{
	switch (gMouseState)
	{				
	case MOUSE_IDLE:
		if (gMouseOver == gMouseDown)
		{
			if (gMouseDown != 0)
			{
				if (mouseinfo[gMouseDown-1].id < 6)
					selectdrill(mouseinfo[gMouseDown-1].id-1);			
				else
				if (mouseinfo[gMouseDown-1].id < 11)
					selectbomb(mouseinfo[gMouseDown-1].id-6);
				else
				if (mouseinfo[gMouseDown-1].id == 11)
				{
					gFuseLength = mousex / 10;
					if (gFuseLength > 12)
						gFuseLength = 12;
				}
				else
				if (gMouseDown == 12)
					ingame_goback();
				else
				if (gMouseDown == 13)
				{
					gTextStartTick = gPhysicsTick;
					gCheckActive = !gCheckActive;
				}
			}
			else
			{
				if (!cursor_blocked())
				{
					gMouseState = MOUSE_DIRECTION;
				}
			}
		}		
		break;
	case MOUSE_DIRECTION:
		gMouseState = MOUSE_IDLE;
		//gMouseActive = 0;
		spawndrill(mx - 120, my);
		break;
	}	
	gMouseDown = 0;
	gMouseIsDown = 0;
	gMouseDrag = 0;
}

int ingame_events()
{
	// Poll for events, and handle the ones we care about.
	SDL_Event event;
	while (SDL_PollEvent(&event)) 
	{
		if (gReplayMode)
		{
			switch (event.type) 
			{
			case SDL_MOUSEBUTTONUP:
				ingame_goback();
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym)
				{
				case SDLK_ESCAPE:
					ingame_goback();
					break;
				}
				break;
			case SDL_QUIT:
				return(0);
			}
		}
		else
		if (gIngameState != STATE_PLAYING)
		{
			switch (event.type) 
			{
			case SDL_MOUSEMOTION:
				// store mouse coordinates for use in render function
				mousex = event.motion.x;
				mousey = event.motion.y;
				mx = mousex;
				my = mousey;
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym)
				{
				case SDLK_ESCAPE:
					ingame_goback();
					break;
				}
				break;
			case SDL_QUIT:
				return(0);
			}
		}
		else
		{
			switch (event.type) 
			{
			case SDL_MOUSEMOTION:
				// store mouse coordinates for use in render function
				mousex = event.motion.x;
				mousey = event.motion.y;
				checkmouseover();

				if (gMouseDown == 11)
				{
					gFuseLength = mousex / 10;
					if (gFuseLength > 12)
						gFuseLength = 12;
					mx = mousex;
					my = mousey;
				}

				if (!gMouseIsDown)
				{
					switch (gMouseState)
					{
					case MOUSE_IDLE:
						mx = mousex;
						my = mousey;
						break;
					}
				}
				
				if (gMouseIsDown && !gMouseDrag && mx > 120)
				{
					if (sqrt(((float)mx-mousex)*((float)mx-mousex)+((float)my-mousey)*((float)my-mousey)) > 10)
					{
						if (!cursor_blocked()) 
						{
							gMouseDrag = 1;
							gMouseState = MOUSE_DIRECTION;
						}
						else
						{
							gMouseIsDown = 0;
						}
					}
				}

				if (gMouseDrag)
				{
					gFuseLength = (int)sqrt(((float)mx-mousex)*((float)mx-mousex)+((float)my-mousey)*((float)my-mousey)) / 20;
					if (gFuseLength > 12)
						gFuseLength = 12;
				}
				break;
			case SDL_MOUSEBUTTONUP:
				if (event.button.button == 3)
				{
					gMouseState = MOUSE_IDLE;
					gMouseIsDown = 0;
				}
				else
				if (event.button.button == 1)
				{
					leftclick();
				}
				break;
			case SDL_MOUSEBUTTONDOWN:
				if (event.button.button == 1)
				{				
					gMouseDown = gMouseOver;
					gMouseIsDown = 1;
				}
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym)
				{
				case SDLK_ESCAPE:
					ingame_goback();
					break;
				case SDLK_1:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 0;
					}
					break;
				case SDLK_2:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 1;
					}
					break;
				case SDLK_3:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 2;
					}
					break;
				case SDLK_4:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 3;
					}
					break;
				case SDLK_5:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 4;
					}
					break;
				case SDLK_6:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 5;
					}
					break;
				case SDLK_7:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 6;
					}
					break;
				case SDLK_8:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 8;
					}
					break;
				case SDLK_9:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 10;
					}
					break;
				case SDLK_0:
					if (gMouseState == MOUSE_IDLE || gMouseState == MOUSE_DIRECTION)
					{
						gFuseLength = 12;
					}
					break;
				case SDLK_q:
					if (gMouseState == MOUSE_IDLE ||  gMouseState == MOUSE_DIRECTION)
					{
						selectdrill(0);
					}
					break;
				case SDLK_w:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectdrill(1);
					}
					break;
				case SDLK_e:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectdrill(2);
					}
					break;
				case SDLK_r:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectdrill(3);
					}
					break;
				case SDLK_t:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectdrill(4);
					}
					break;
				case SDLK_a:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectbomb(0);
					}
					break;
				case SDLK_s:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectbomb(1);
					}
					break;
				case SDLK_d:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectbomb(2);
					}
					break;
				case SDLK_f:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectbomb(3);
					}
					break;
				case SDLK_g:
					if (gMouseState == MOUSE_IDLE  || gMouseState == MOUSE_DIRECTION)
					{
						selectbomb(4);
					}
					break;
				case SDLK_SPACE:
				case SDLK_RETURN:
					leftclick();
					break;
				}
				break;
			case SDL_QUIT:
				return(0);
			}
		}
	}
	return 1;
}

#undef FILE 
#undef fseek
#undef ftell
#undef fgetc
#undef fread
#undef fclose
#undef fopen
#undef fprintf
#undef fputc
#undef fputs

void save_replay()
{
	char temp[128];
	sprintf(temp,"%s.replay",gCurrentLevel->filename);
	FILE * f = fopen(temp,"wb");
	if (f == NULL)
		return;
	fwrite(replaybuffer,sizeof(ReplayEvent) * gReplayIndex, 1, f);
	fclose(f);
}

int replay_exists(Level *l)
{
	char temp[128];
	sprintf(temp,"%s.replay",l->filename);
	FILE * f = fopen(temp,"rb");
	if (f == NULL)
		return 0;
	fclose(f);
	return 1;
}

void read_replay(Level *l)
{
	char temp[128];
	sprintf(temp,"%s.replay",l->filename);
	FILE * f = fopen(temp,"rb");
	if (f == NULL)
		return;
	fseek(f,0,SEEK_END);
	int len = ftell(f);
	fseek(f,0,SEEK_SET);
	if (len > 1024 * sizeof(ReplayEvent))
		len = 1024 * sizeof(ReplayEvent);
	fread(&replaybuffer, len, 1, f);
	fclose(f);
}