#include "charge.h"

void shake()
{
	int i, j, c = 0;
	for (i = 0; i < 599; i++)
	{
		for (j = 0; j < 680; j++, c++)
		{
			if (grainmap[c] >= 0)
			{
				int shakes = 0;

				if (grainmap[c+680] < 0)
					shakes++;
				if (grainmap[c-1] < 0 && j > 0)
					shakes++;
				if (grainmap[c+1] < 0 && j < 679)
					shakes++;

				while (shakes)
				{
					if (particle[grainmap[c]].type & GRAIN_NO_MOVE)
					{
						if (!(prand.genrand_int32() & 3))
							particle[grainmap[c]].hits--;
						if (particle[grainmap[c]].hits <= 0)
						{
							particle[grainmap[c]].type &= ~GRAIN_NO_MOVE;
						}
					}
					shakes--;
				}
			}
		}
	}
}

void collapse()
{
	int i, j, c;
	for (i = 598; i > 0; i--)
	{
		int linepos = i * 680;

		for (j = 0; j < 680; j++)
		{
			int left = 680 - j;
			int right = j;			
			int x = j;
			if (i & 1)
			{
				c = linepos + j;
				int t = left; left = right; right = t;
			}
			else
			{
				c = linepos + 679 - j;
				x = 679 - x;			
			}

			int grainmoved = -1;
			int currentgraintype = particle[grainmap[c]].type;

			if (grainmap[c] >= 0 && !(currentgraintype & GRAIN_NO_MOVE))
			{
				if (grainmap[c + 680] < 0)
				{
					grainmoved = grainmap[c];
					grainmap[c + 680] = grainmap[c];
					grainmap[c] = -1;
				}
				else
				if (!(currentgraintype & GRAIN_COARSE))
				{
					if ((i&1)^(j&1))
					{
						if (grainmap[c + 681] < 0 && right > 1)
						{
							grainmoved = grainmap[c];
							grainmap[c + 681] = grainmap[c];
							grainmap[c] = -1;
						}
						else
						if (grainmap[c + 679] < 0 && left > 1)
						{
							grainmoved = grainmap[c];
							grainmap[c + 679] = grainmap[c];
							grainmap[c] = -1;
						}					
						else
						if (currentgraintype & (GRAIN_FINE | GRAIN_FLUID))
						{
							if (grainmap[c + 682] < 0  && right > 2)
							{
								grainmoved = grainmap[c];
								grainmap[c + 682] = grainmap[c];
								grainmap[c] = -1;
							}
							else
							if (grainmap[c + 678] < 0 && left > 2)
							{
								grainmoved = grainmap[c];
								grainmap[c + 678] = grainmap[c];
								grainmap[c] = -1;
							}
							else
							if (particle[grainmap[c]].type & GRAIN_FLUID)
							{
								if (grainmap[c + 1] < 0  && right > 1)
								{
									grainmoved = grainmap[c];
									grainmap[c + 1] = grainmap[c];
									grainmap[c] = -1;
								}
								else
								if (grainmap[c - 1] < 0 && left > 1)
								{
									grainmoved = grainmap[c];
									grainmap[c - 1] = grainmap[c];
									grainmap[c] = -1;
								}
							}
						}
					}
					else
					{
						if (grainmap[c + 679] < 0  && left > 1)
						{
							grainmoved = grainmap[c];
							grainmap[c + 679] = grainmap[c];
							grainmap[c] = -1;
						}
						else
						if (grainmap[c + 681] < 0 && right > 1)
						{
							grainmoved = grainmap[c];
							grainmap[c + 681] = grainmap[c];
							grainmap[c] = -1;
						}
						else
						if (currentgraintype & (GRAIN_FINE |GRAIN_FLUID))
						{
							if (grainmap[c + 678] < 0 && left > 2)
							{
								grainmoved = grainmap[c];
								grainmap[c + 678] = grainmap[c];
								grainmap[c] = -1;
							}
							else
							if (grainmap[c + 682] < 0 && right > 2)
							{
								grainmoved = grainmap[c];
								grainmap[c + 682] = grainmap[c];
								grainmap[c] = -1;
							}
							else
							if (currentgraintype & GRAIN_FLUID)
							{
								if (grainmap[c - 1] < 0 && left > 1)
								{
									grainmoved = grainmap[c];
									grainmap[c - 1] = grainmap[c];
									grainmap[c] = -1;
								}
								else
								if (grainmap[c + 1] < 0  && right > 1)
								{
									grainmoved = grainmap[c];
									grainmap[c + 1] = grainmap[c];
									grainmap[c] = -1;
								}
							}
						}
					}
				}
				if (grainmoved >= 0)
				{
					if (particle[grainmoved].type & GRAIN_REPLICATE && !(c & 15))
					{
						if (particle[gReplicateParticle].hits == UNUSED_PARTICLE)
						{
							particle[gReplicateParticle] = particle[grainmoved];
							grainmap[c] = gReplicateParticle;							
							gReplicateParticle++;
						}
					}

					if (particle[grainmoved].type & GRAIN_NO_HARM)
					{
						particle[grainmoved].type &= ~GRAIN_NO_HARM; // don't count twice
						gCurrentNoharm++;
					}
				}
			}
		}
	}
}

void add_delayed_dig(int x, int y, int r, int pow)
{	
	if ((prand.genrand_int32() & 7) != 0)
		return;
		
	DelayedDig * d = new DelayedDig;
	d->next = gDelayedDigRoot;
	gDelayedDigRoot = d;
	d->x = x;
	d->y = y;
	d->r = r;
	d->pow = pow;
}

void dig(int ofs, int pow)
{
	if (grainmap[ofs] < 0) 
		return;
	if (particle[grainmap[ofs]].type & GRAIN_FLUID)
		return;
	if (particle[grainmap[ofs]].hits > pow)
	{		
		particle[grainmap[ofs]].hits -= pow;
		if (particle[grainmap[ofs]].hits > pow * 4)
			add_sparkle(ofs % 680, ofs / 680);
		return;
	}
	if (particle[grainmap[ofs]].type & GRAIN_NO_DESTROY)
	{
		add_sparkle(ofs % 680, ofs / 680);
		if (particle[grainmap[ofs]].type & GRAIN_NO_MOVE)
		{
			particle[grainmap[ofs]].type &= ~GRAIN_NO_MOVE;
		}
		return;
	}
	if (particle[grainmap[ofs]].type & GRAIN_VALUABLE)
	{
		gCurrentValuables++;
	}
	if (particle[grainmap[ofs]].type & GRAIN_NO_HARM)
	{
		gCurrentNoharm++;
	}
	if (particle[grainmap[ofs]].type & GRAIN_FUND)
	{
		gCurrentMoney += 5;
	}
	if (particle[grainmap[ofs]].type & GRAIN_EXPLOSIVE)
	{
		grainmap[ofs] = -1; // no infinite recursion, thanks
		add_delayed_dig(ofs % 680, ofs / 680, 6, 8);
	}

	grainmap[ofs] = -1;
	gCurrentDugTotal++;
}

void drillcircle(int x, int y, int r, int pow)
{
	int i, j;
	for (i = 0; i < 2 * r; i++)
	{
        // vertical clipping: (top and bottom)
		if ((y - r + i) >= 0 && (y - r + i) < 600)
		{
			int len = (int)sqrt((float)(r * r - (r - i) * (r - i))) * 2;
			int xofs = x - len / 2;

			// left border
			if (xofs < 0)
			{
				len += xofs;
				xofs = 0;
			}

			// right border
			if (xofs + len >= 680)
			{
				len -= (xofs + len) - 680;
			}
			int ofs = (y - r + i) * 680 + xofs;
			
			// note that len may be 0 at this point, 
			// and no pixels get drawn!
			for (j = 0; j < len; j++)
				dig(ofs + j, pow);
		}
	}
}




void drillrect(int x, int y, int width, int height, int pow)
{
	int i, j;
	for (i = 0; i < height; i++)
	{
		// vertical clipping: (top and bottom)
		if ((y + i) >= 0 && (y + i) < 600)
		{
			int len = width;
			int xofs = x;

			// left border
			if (xofs < 0)
			{
				len += xofs;
				xofs = 0;
			}

			// right border
			if (xofs + len >= 680)
			{
				len -= (xofs + len) - 680;
			}
			int ofs = (i + y) * 680 + xofs;

			// note that len may be 0 at this point, 
			// and no pixels get drawn!
			for (j = 0; j < len; j++)
				dig(ofs + j, pow);
		}
	}
}
