#include "charge.h"

void drawdescription(int x, int y, int w, const char *desc, int lastchar)
{
	int x1 = x;
	int p = 0;
	char temp[256];
	char *t = temp;
	int c = 0;
	
	while (*desc && c < lastchar)
	{
		if (*desc == '\\')
		{
			if (*(desc+1)=='n')
			{
				*t = 0;
				blitstring(x,y,temp);
				t = temp;
				desc++;
				desc++;
				x = x1;
				y += 8;
				p = 0;
			}
			else
			{
				*t = *desc;
				t++;
				desc++;
				c++;
				p += 8;
			}
		}		
		else
		{
			*t = *desc;
			t++;
			desc++;
			c++;
			p += 8;
			if (p >= w)
			{
				while (*t != ' ')
				{
					t--;
					desc--;
				}
				desc++;
				*t = 0;
				blitstring(x,y,temp);
				t = temp;
				p = 0;
				x = x1;
				y += 8;
			}
		}
	}
	*t = 0;
	blitstring(x,y,temp);
}

void single_render()
{
	if (SDL_GetTicks() - gStateStartTick < 500)
	{
		gTextStartTick = SDL_GetTicks();
	}
	int t = 500 - (SDL_GetTicks() - gStateStartTick);
	if (t < 0) t = 0;
	t = (int)(SMOOTHSTEP(t / 500.0f)*500);	

	int q = 500 - (SDL_GetTicks() - gTextStartTick);
	if (q < 0) q = 0;
	q = (int)(SMOOTHSTEP(q / 500.0f)*600);	
	

	blit(gMenubg,0,0,800,600);
	drawrectb(0,50+t-4,800,40,0);
	blitstring32((800 - (int)strlen("Select mission") * 32) / 2,50+t,"Select mission");

	blit(gCurrentLevel->thumb,100 - q,100,170,150);
	drawrectb(276+q,100-4,430,156,0);
	blitstring32(280+q,100,gCurrentLevel->name);
	char temp[80];
	sprintf(temp,"Hiscore:%d",gCurrentLevel->hiscore);
	blitstring(280+q,140,temp);
	int p = 160;
	sprintf(temp,"Budget: $%d",gCurrentLevel->money);
	blitstring(280+q,p,temp); p+=16;
	blitstring(280+q,p,"Goals:"); p+=8;
	if (gCurrentLevel->valuables > 0)
	{
		sprintf(temp,"Collect at least: %3.0f%%",gCurrentLevel->valuables * 100);
		blitstring(280+q,p,temp); p+=8;
	}
	if (gCurrentLevel->noharm > 0)
	{
		sprintf(temp,"Unharmed property: %3.0f%%",gCurrentLevel->noharm * 100);
		blitstring(280+q,p,temp); p+=8;
	}
	if (gCurrentLevel->time > 0)
	{
		sprintf(temp,"Time limit: %02d:%02d",gCurrentLevel->time / 60,gCurrentLevel->time % 60);
		blitstring(280+q,p,temp); p+=8;
	}
	if (gCurrentLevel->pass == 1)
	{
		blitstring(280+q,p,"Must pass from point A to B"); p+=8;
	}
	if (gCurrentLevel->pass == 2)
	{
		blitstring(280+q,p,"Must fill target container"); p+=8;
	}
	drawrectb(96+t,276,608,200,0);
	drawdescription(100+t,280,600,gCurrentLevel->desc, (SDL_GetTicks() - gTextStartTick) / 25);

	gMouseOver = 0;

	if (textbutton(1,SingleMenu.pos[0].x - t,SingleMenu.pos[0].y,"Previous"))
	{
		if (gCurrentLevel == gLevelList)
			gCurrentLevel = NULL;
		Level * l = gLevelList;
		while (l->next != gCurrentLevel) l = l->next;
		gCurrentLevel = l;
		gTextStartTick = SDL_GetTicks();
	}

	if (textbutton(2,SingleMenu.pos[1].x + t,SingleMenu.pos[1].y,"Next"))
	{
		gCurrentLevel = gCurrentLevel->next;
		if (gCurrentLevel == NULL)
			gCurrentLevel = gLevelList;
		gTextStartTick = SDL_GetTicks();
	}

	if (textbutton(3,SingleMenu.pos[2].x - t,SingleMenu.pos[2].y,"Play"))
	{
		reset(gCurrentLevel);
		gReplayMode = 0;
		changestate(STATE_INGAME);
	}

	if (textbutton(4,SingleMenu.pos[3].x + t,SingleMenu.pos[3].y,"Back"))
	{
		changestate(STATE_MENU);
	}

	if (gCurrentLevel->replay_exists && textbutton(2134,SingleMenu.pos[4].x - t,SingleMenu.pos[4].y,"Replay"))
	{
		reset(gCurrentLevel);
		gReplayMode = 1;
		read_replay(gCurrentLevel);
		changestate(STATE_INGAME);
	}


	if (!gMouseDown) 
		gMouseActive = 0;

	blitcursor(mousex, mousey, 0); // selector cursor

}
