#define RAMFILIZE // don't use ramfile for this file
#include "charge.h"



void wipe_states()
{
	StateRepository * walker = gStateRoot;
	while (walker)
	{
		StateRepository *s = walker;
		walker = walker->next;
		delete s;
	}
	gStateRoot = NULL;
}

void set_state(const char *string, int value)
{
	StateRepository * walker = gStateRoot;
	while (walker && _stricmp(walker->string, string) != 0)
	{
		walker = walker->next;
	}
	if (walker)
	{
		walker->value = value;
		return;
	}
	walker = new StateRepository;
	walker->next = gStateRoot;
	gStateRoot = walker;
	walker->value = value;
	int len = (int)strlen(string);
	walker->string = new char[len+1];
	memcpy(walker->string, string, len);
	walker->string[len] = 0;
}

int read_state(const char * string)
{
	StateRepository * walker = gStateRoot;
	while (walker && _stricmp(walker->string, string) != 0)
	{
		walker = walker->next;
	}
	if (walker)
	{
		return walker->value;
	}
	return 0;
}

void deserialize_states()
{
	wipe_states();
	FILE * f = fopen("charge.sav", "rb");
	if (!f)
		return;
	while (!feof(f))
	{
		char temp[1024];
		int l;
		if (fread(&l, 1, 4, f) != 4) break;
		if (fread(temp, 1, l, f) != l) break;
		temp[l] = 0;
		if (fread(&l, 1, 4, f) != 4) break;
		set_state(temp, l);
	}
	fclose(f);
}

void serialize_states()
{
	FILE * f = fopen("charge.sav", "wb");
	StateRepository * walker = gStateRoot;
	while (walker)
	{
		int l = (int)strlen(walker->string);
		fwrite(&l,1,4,f);
		fwrite(walker->string,1,l,f);
		fwrite(&walker->value,1,4,f);
		walker = walker->next;
	}
	fclose(f);
}

